/*
 * time_base.h
 *
 *  Created on: Jan 13, 2024
 *      Author: hussamaldean
 */

#ifndef TIME_BASE_H_
#define TIME_BASE_H_

#include "stdint.h"

/*
 * @brief This function will initialize SysTick
 * to generate 1ms interrupt.
 * @param freq source frequency of SysTick.
 * @return nothing.
 * @see Generic ARM CortexM4 user guide.
 * */

void Time_Base_Init(uint32_t freq);

/*
 * @brief This function will return the current millis.
 *
 * @param nothing.
 * @return current time in millis.
 * */
uint64_t Tick_Get();


/*
 * @brief This function will spin lock the CPU to delay for the required
 * amount
 * @param time to be delayed in milliseconds.
 * @return nothing.
 * */
void delay(uint32_t time);


#endif /* TIME_BASE_H_ */
