/*
 * LEDs.c
 *
 *  Created on: Jan 13, 2024
 *      Author: hussamaldean
 */


#include "LEDs.h"
#include "stm32f7xx.h"

void LEDs_Init(void)
{
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOBEN;

	GPIOB->MODER|=GPIO_MODER_MODER0_0|GPIO_MODER_MODER7_0|GPIO_MODER_MODER14_0;
	GPIOB->MODER&=~(GPIO_MODER_MODER0_1|GPIO_MODER_MODER7_1|GPIO_MODER_MODER14_1);
}

void LED_Write(LEDs led, LEDState state)
{
	switch (led)
	{
		case Green:
			if(state==OFF)
			{
				GPIOB->BSRR=GPIO_BSRR_BR0;
			}
			else
			{
				GPIOB->BSRR=GPIO_BSRR_BS0;
			}
			break;

		case Blue:
			if(state==OFF)
			{
				GPIOB->BSRR=GPIO_BSRR_BR7;
			}
			else
			{
				GPIOB->BSRR=GPIO_BSRR_BS7;
			}
			break;

		case Red:
			if(state==OFF)
			{
				GPIOB->BSRR=GPIO_BSRR_BR14;
			}
			else
			{
				GPIOB->BSRR=GPIO_BSRR_BS14;
			}
			break;

		default : break;

	}

}
